#ifndef BLENDER_RENDERMANAGER_H_INCLUDED
#define BLENDER_RENDERMANAGER_H_INCLUDED

#include "stdafx.h"
#define MYSQLPP_SSQLS_NO_STATICS
#include "RenderingMax.h"

using namespace std;

namespace CloudResourceManager
{

    class Blender_RenderManager
    {
    private:
        MySqlppHelper mySqlppHelper;
        string GetFileExtbyFotmat(const string& fileFormat);
        //Render Task Input Parameter Format: StartFrame:EndFrame:Format
        bool ParseInputParameter(const string& inputParam, string& startFrame, string& endFrame, string& outFormat);
        string GetResultFileName(const string& strPlatform, const StringMap& jobContext);

        bool GenericSubmitJob(int nTaskId, int jobType, StringMap& jobContext);

        // strFrame, strFormat would be null except for render jobs
        string GenericGenerateJobFiles(const string& taskId, const string& strPlatform, const string& jobId,
                int jobType, StringMap& jobContext);

        /// <summary>
        /// Initiate Instance:For blender rendering instance, it means that it generate s3 downdload job for user content file transfer.
        /// </summary>
        /// <param name="TaskId">taskid of a given task output file format</param>
    public:
        bool InitiateInstanceByTask(int taskId);

        bool SubmitRenderJob(int taskId, const string& frame, const string& format);
        /// <summary>
        /// Initiate Task:For blender rendering task, it means that it generate s3 upload job for user content file transfer.
        /// </summary>
        /// <param name="myTask">a given task</param>
        bool InitiateTask(int taskId);

        /// <summary>
        /// Start a task :For blender rendering task, it means that it check the s3 upload task, if the s3 upload job is done, then change the task status as "started"
        /// </summary>
        /// <param name="myTask">a given task</param>
        bool StartTask(int taskId);        /// <summary>
        ///generate related rendering jobs by a given task
        /// </summary>
        /// <param name="myTask">the given task</param>
        ///
        ///
        int GenerateRenderJobs(const Tasks& myTask);

    };
}

#endif // BLENDER_RENDERMANAGER_H_INCLUDED
