#include <Wt/MySqlCon.h>
#include <mysql++.h>
#include "DBTableWidget.h"

using namespace mysqlpp;


DBTableWidget::DBTableWidget(const std::string& strTableName, WContainerWidget* parent)
    :WTable(parent), tableName(strTableName)
{
    setStyleClass("Wt-DBTableWidget");
    setStyleClass("Wt-DBTableWidget td");
    setStyleClass("Wt-DBTableWidget th");
    Initialize();
}

#if 1
void DBTableWidget::Initialize()
{
    MySqlCon mySqlCon;
    mysqlpp::Connection& con = mySqlCon.con;

    Query q = con.query();
    q << "select * from "<< tableName;
    UseQueryResult res = q.use();
    if (res)
    {
        int i;
        for (i = 0; i < res.num_fields(); i ++)
        {
            elementAt(0, i)->addWidget(new WText(res.field_name(i)));
        }

        int r = 1, c = 0;
        while (Row row = res.fetch_row())
        {
            for (c = 0; c < res.num_fields(); c ++)
            {
                elementAt(r, c)->addWidget(new WText(row[c].c_str()));
            }
            r++;
        }
        setHeaderCount(1);
    }
}
#else

void DBTableWidget::Initialize()
{
    MySqlCon mySqlCon;
    mysqlpp::Connection& con = mySqlCon.con;

    Query q = con.query();
    q << "select * from "<< tableName;
    UseQueryResult res = q.use();
    if (res)
    {
        int i;
        for (i = 0; i < res.num_fields(); i ++)
        {
            elementAt(0, i)->addWidget(new WText(res.field_name(i)));
        }

        int r = 1, c = 0;
        while (Row row = res.fetch_row())
        {
            for (c = 0; c < res.num_fields(); c ++)
            {
                elementAt(r, c)->addWidget(new WText(row[c].c_str()));
            }
            r++;
        }
        setHeaderCount(1);
    }
}
#endif


